<!DOCTYPE html>
<html>
<head>
    <title>Scriptopic</title>
    <link href='i/favicon.png?<?php echo VERSION;?>' rel='icon' type='image/svg'>
    <link rel="stylesheet" type="text/css" href="style.css?<?php echo VERSION;?>">
    <meta charset="utf-8">
    <?php 
        $actions=[
            'emboss'=>['',"Crée un effet embossé",],
            'edges'=>['','Détection des contours'],
            'negative'=>['',"Crée le négatif"],
            'sketch'=>['','Effet de bruit'],
            'grey'=>['',"Noir et blanc"],
            'sepia'=>['',"Applique un effet de sépia"],
            'gaussian'=>['',"Applique un flou"],
            'pixel'=>['taille[,flou]',"Pixelise avec des blocks de la taille spécifiée. Si flou est à 0, un filtre de flou est retiré"],
            'brightness'=>['intensite',"Fait varier la luminosité (valeurs négatives ou positives)"],
            'contrast'=>['intensite',"Fait varier le contraste (valeurs négatives ou positives)"],
            'colorize'=>['FF0000[,intensité]',"Applique un filtre de couleur. la valeur intensité varie de 0 (total [par défaut]) à 127 (transparent)"],
            'resize'=>['largeur en px|%,hauteur en in px|%',"Redimensionne à la taille spécifiée (en px ou en %). Si une des valeurs est à -1, la deuxième est calculée pour préserver les proportions"],
            'crop'=>['x en px|%,y en px|%,largeur en px|%,hauteur en in px|%',"Découpe une portion de la taille w,y commençant à x,y (toutes les valeurs peuvent être en pixels ou en %)"],
            'rotate'=>['angle en degres',"Effectue une rotation de angle degrés."],
            'mirror'=>['',"Fait un miroir horizontal"],
            'flip'=>['horizontal|vertical|both / h|v|b / 0|1|2',"Retourne une image (horizontal, vertical ou les deux (both).",'select'],
            'text'=>['texte,x,y,couleur,taille,police[,angle]',"Ajoute un texte aux coordonnées x,y [x=px|%|left|right|center , y=px|%|top|bottom|center]. La police peut-être comic|monospace|round|sans|serif. "]
        ];
    ?>
    
</head>
<body>
    <header><h1><img src="i/favicon.png" class="logo"/> Scriptopic</h1><h5>v<?php echo VERSION;?></h5></header>
    

    <div class="main" id="content">
        <nav>
            <div>
                <label><img src="i/link.svg" class="icon"/> URL de l'image</label>
                <input id="url" placeholder="http://www.site.com/image.jpg" type="url" value="<?php echo $url; ?>" oninput="update();"/>
            </div>
            <div>
                <label><img src="i/action.svg" class="icon"/> Actions</label>
                <nav id="toolbar">                    
                    
                    <?php 
                        foreach ($actions as $a=>$p){

                            if ($p){$args=$p[0];}else{$args='';}
                            $help=$p[1];
                            echo "<button id='$a' param='$args' title='$help'>$a</button>";
                        }
                     ?>
                   
                </nav>
            </div>
            <div id="script">
              
            </div>
            <p>
                    <a href="" id="test" target="result" class="button" title="the result will not be saved">Tester le script</a>
                </p>
            <label><img src="i/magic.svg" class="icon"/> Résultat</label>
            <div class="border">
                <p>       
                    <label>URL de l'image modifiée</label>     
                    <input type="text" id="apiurl" value="" class="textbox" readonly title="double-clic pour copier"/>
                </p>
                <p>       
                    <label>Balise img à coller</label>     
                    <input type="text" id="img" value="" class="textbox block" readonly title="double-clic pour copier"/>
                </p>
                <p>
                    <label>Bookmarklet vers ce script</label>
                    <a id="bookmarklet" href='' title="Bookmarklet pour appliquer ces modifications à une image" class="button"></a>
                </p>
                 <p>
                    <label>Script au format JSON</label>
                    <textarea id="json" class="textbox" readonly></textarea>
                </p>
                
            </div>
        </nav>
        
        

    </div>
    <footer>
        Scriptopic by <a href="https://warriordudimanche.net/contact">Bronco</a> 
        - 
        <a href="javascript:javascript:(function(){url=encodeURIComponent(location.href);window.open('<?php echo getURL();?>/?i='+url,'mybookmarklet','');})();" title="to work on an internet image">Bookmarklet</a>
        - 
        <a href="?download" >Download this app</a>

    </footer>

<script type="text/javascript" src="VanillaJS.js"></script>
<script type="text/javascript">
    const root="<?php echo getURL();?>/";
    const bookmarklet_href_tpl="javascript:javascript:(function(){url=encodeURIComponent(location.href);window.open(\'"+root+"/?i=\'+url+\'&script=%TEXT%\',\'mybookmarklet\',\'\');})();";
    const u=first("#url");
    const test=first("#test");
    const script=first('#script');
    const bookmarklet=first('#bookmarklet');
    const apiurl=first('#apiurl');
    const json=first('#json');
    const img=first('#img');

    var current_json_string='';
    var current_commands='';

    function copy(text) {
        if (window.clipboardData && window.clipboardData.setData) {
            // IE specific code path to prevent textarea being shown while dialog is visible.
            return clipboardData.setData("Text", text); 

        } else {
            var textarea = document.createElement("textarea");
            textarea.textContent = text;
            textarea.style.position = "fixed";  // Prevent scrolling to bottom of page in MS Edge.
            document.body.appendChild(textarea);
            textarea.select();
            try {
                return document.execCommand("copy");  // Security exception may be thrown by some browsers.
            } catch (ex) {
                console.warn("Copy to clipboard failed.", ex);
                return false;
            } finally {
                document.body.removeChild(textarea);
            }
        }
    }

    function indentJson(str){
        return str.replace("[{","[\n{").replace("}]","}\n]").replace(/\},/g,"},\n").replace(/\{/g,"    {");
    }

    function jsonize(){
        let commands=all("#script .command");
        let string_json='';
        current_commands='';
        let actions_array=[];
        

        for (action of commands){
            let command_obj={};
            action_string=action.getAttribute('action');
            param_string=action.value;
            current_commands+=" "+action_string;
            if(param_string.indexOf(',')!=-1){
                param_string=param_string.split(',');
            }
            command_obj[action_string]=param_string
            
            actions_array.push(command_obj);
        }
        current_json_string = JSON.stringify(actions_array);
        json.value=indentJson(current_json_string);
        return current_json_string;
    }
    function updateLinks(){
        test.href=root+'?dontsave&force&i='+u.value+"&script="+current_json_string;
        apiurl.value=root+'?i='+u.value+"&script="+current_json_string;
        img.value='<img src=\''+apiurl.value+'\'/>';
        bookmarklet.href=bookmarklet_href_tpl.replace("%TEXT%",current_json_string);
        bookmarklet.innerHTML="Scriptopic"+current_commands;
    }
    function update(){
        jsonize();
        updateLinks();
    }


on("dblclick",apiurl,(e)=>{
    copy(e.target.value);
    alert('Copié!');
})
on("dblclick",img,(e)=>{
    copy(e.target.value);
    alert('Copié!');
})
on("click","#toolbar button",(e)=>{
    let button=e.target;
    let actions_list="<?php foreach($actions as $a=>$p){if (!$p[0]) echo ' '.$a.',';} ?>"

    let param=attr(button,"param");
    let help=attr(button,"title");
    let command=button.id;  

    let line=create('li',{title:help});
    let close_button=create('input',{class:"remove_parent",type:"button",value:"✖",onclick:"remove(this.parentNode);update();"});
    let span_command=create('span');
    span_command.innerHTML=command;

    let input_class=actions_list.indexOf(command)!=-1?"hidden":"text";
    let input_param=create("input",{class:"command "+input_class,action:command,type:"text",placeholder:param,oninput:"update();",value:""});
    line.appendChild(span_command);
    line.appendChild(input_param);
    line.appendChild(close_button);
    script.appendChild(line)
    
    update();
});

    on("click","#regen",(e)=>{/*
        back=u.value?u.value:i.value;
        texte=t.value.replace(/[\n]/g,'\\n');
        url="?force&dontsave&t="+texte+"&c="+c.value+"&f="+f.value+"&fs="+fs.value+"&i="+back;
        img.src=url;*/
    });
    on("click","#geturl",(e)=>{
        prompt("Copier le lien vers cette image",img.src.replace("force&dontsave&",""));
        
    });/*
    on("click","#test",(e)=>{
        if (u.href==undefined||u.href==""){
            alert("Pas d'url d'image !")
            e.preventDefault();
            return false;
        }
    })*/
</script>