<?php 
class zip{
	private $version="1.1";
	
	private $zipfile='';
	private $destination='';
	private $source='';
	private $fileslist=[];

	public function __construct(){

	}

	###########################
	# METHODS #################
	###########################

	# create
	###########################
	public function create($source=null,$destination=null){
		if (
			  empty($source)
			&&empty($destination)
			&&empty($this->source)
			&&empty($this->destination)
			&&(empty($this->fileslist)||!is_array($this->fileslist))
		){
			return false;
		}

		$this->destination=empty($destination)?$this->destination:$destination;
		$this->fileslist  =empty($this->fileslist)?$this->listFiles($source):$this->fileslist;
		
		$zip = new ZipArchive();
		if (is_file($this->destination)){
			unlink($this->destination);
		}
		if (!$zip->open($this->destination, ZIPARCHIVE::CREATE)) {
			throw new Exception("Error creating zipArchive", 1);			
			return false;
		}

		foreach ($this->fileslist as $file) {
			$file=str_replace('./', '', $file);
			if (
				$file!=$source
				&&is_file($file)	
			){
				$zip->addFile($file);
			}elseif (
				$file!=$source
				&&is_dir($file)	
			){
				$zip->addEmptyDir($file);
			}
		}
		
		$this->zipfile=$destination;
	}
	private function addSlash($string){
        if (substr($string,strlen($string)-1,1)!='/'&&!empty($string)){return $string.'/';}else{return $string;}
    }
    private function recursiveDirContent($root=null,$filter=null){
        if (empty($root)){return false;}
        if (!is_dir($root)){return array($root);}
        $iter = new \RecursiveIteratorIterator(
            new \RecursiveDirectoryIterator($root, \RecursiveDirectoryIterator::SKIP_DOTS),
            \RecursiveIteratorIterator::SELF_FIRST,
            \RecursiveIteratorIterator::CATCH_GET_CHILD # Ignore "Permission denied"
        );

        $paths = array($root);
        foreach ($iter as $path => $dir) {      
            if (
                ($filter && stripos($path,$filter)!==false)
                || !$filter
            ){
                $paths[] = $path; 
            }
        }

        return $paths;
    }
	# unzip
	###########################
	public function unzip($file,$destination){
		if (
			  empty($source)
			&&empty($destination)
			&&empty($this->source)
			&&empty($this->destination)
		){
			return false;
		}
		$zip = new ZipArchive() ;
	    if ($zip->open($file) !== TRUE) {return false;} 
	   	$zip->extractTo($destination); 
	    $zip->close(); 
	    return true; 
	}
	
	# download
	###########################
	public function download(){
		header("Location: ".$this->zipfile);
		exit;
	}

	# listFiles
	###########################
	public function listFiles($source=null,$exclude=null){
		$source         =empty($source)?$this->source:$source;		
		$source         =$this->addSlash($source);		
		$this->fileslist=$this->recursiveDirContent($source);
		$this->fileslist=array_reverse(array_reverse($this->fileslist));
	    # delete zip file from list
	    if ($exclude){
		    foreach ($this->fileslist as $key => $value) {
		        if (preg_match('#'.$exclude.'#',$value)){
		           unset($this->fileslist[$key]);
		        }
		    }
		}
	    return $this->fileslist;
	}

	# getters
	public function getVersion(){return $this->version;}
	public function getDestination(){return $this->destination;}
	public function getSource(){return $this->source;}
	public function getFilesList(){return $this->fileslist;}

	# setters
	public function setVersion($value=null){$this->version=$value;}
	public function setDestination($value=null){$this->destination=$value;}
	public function setSource($value=null){$this->source=$value;}
	public function setFilesList($value=null){$this->fileslist=$value;}
}